/**
 * Program Name: parseXMLBean.java
 * Comments: Several convenience methods for manipulating the ApplDesc.xml file
 * This Bean may be converted into a webflow module later.
 *
 * Note the package name.  XSIL looks for extensions in a directory called
 * "extensions" in the classpath.  In the ApplDesc.xml file, we have the
 * line
 *       <XSIL Name="Application Descriptor" Type="generic.parseXMLDesc">
 * so we must put parseXMLDesc.class in the directory extensions/generic/ 
 * directory somewhere in the classpath (such as WEB-INF/classes).
 */

package extensions.generic;

import java.util.*;
import org.escience.XSIL.*;
import java.io.*;

public class parseXMLBean {

    static parseXMLList parsexmllist;
    static XSIL root;
    static parseXMLDesc parsexmldesc;

    public parseXMLBean(){
    }

    public static void init(String xmlFileName) {
	boolean ss = true;
	root = new XSIL(xmlFileName,ss);
	XSIL child;

	for(int ichild=0;ichild<root.getChildCount();ichild++) {
            child = root.getChild(ichild);
	    parsexmllist = (parseXMLList)child;
        }
    }
    
    /**
     * This method should return the names of all of the applications.
     */

    public Vector getApplications() {
	Vector appLists = parsexmllist.getParseXMLappListsName();
	return appLists;
    }

    /**
     * This method should return the number of input files 
     * for a particular application.
     */
    public String getNumberOfInFiles(String appIdVal) {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}
	tmp = parsexmldesc.getNumberOfInFiles();
	return tmp;
    }

    /**
     * This method should return the value of the parameter
     * for a particular application.
     */
    public String getNumberOfInParams(String appIdVal) {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}
	tmp = parsexmldesc.getNumberOfInParams();
	return tmp;
    }

    public String getNumberOfOutFiles(String appIdVal) {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}
	tmp = parsexmldesc.getNumberOfOutFiles();
	return tmp;
    }

    public String getNumberOfOutParams(String appIdVal) {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}
	tmp = parsexmldesc.getNumberOfOutParams();
	return tmp;
    }

    public String getIOStyle(String appIdVal) {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}
	tmp = parsexmldesc.getIOStyle();
	return tmp;
    }

    /**
     * This method returns the each column of the table for a particular 
     * application. Must provide application id, column name
     */

    public Vector getHostLists(String appIdVal) {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}

	Vector hostname = parsexmldesc.getHostList();
	return hostname;
    }

    /**
     * The Table includes five columns, HostName, QueueType, ExecPath,
     * WorkDir, QsubPath. The column,"HostName" is key value.
     * if you have host name, according to application type,
     * you have other columns which the "HostName" column belongs to.
     */

    public String getMatchTag(String appIdVal, String machineID, String tagID)
    {
	Vector appList = parsexmllist.getParseXMLappLists();
	Vector appListName = parsexmllist.getParseXMLappListsName();
	String tmp = null;

	for(int i = 0; i < appListName.size(); i++) {
	    tmp = (String)appListName.elementAt(i);
	    if(tmp.equals(appIdVal)) { 
		parsexmldesc = (parseXMLDesc)appList.elementAt(i);
		break;
	    }
	}

	Vector hostname = parsexmldesc.getHostList();
	Vector pairlist = new Vector();

	if(tagID.equals("QueueType")) 
	    pairlist = parsexmldesc.getQueuetypeList();
	else if(tagID.equals("ExecPath")) 
	    pairlist = parsexmldesc.getExecpathList();
	else if(tagID.equals("WorkDir"))
	    pairlist = parsexmldesc.getWorkdirList();
	else if(tagID.equals("QsubPath"))
	    pairlist = parsexmldesc.getQsubpathList();
	else System.err.println("No Table List!!!!");	

	for(int i = 0; i < hostname.size(); i++) {
	    tmp = (String)hostname.elementAt(i);
	    if(tmp.equals(machineID)) { 
		tmp = (String)pairlist.elementAt(i);
		break;
	    }
	}
	return tmp;
    }
}    





